<?php

namespace ACL\Repositories;

use ACL\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class UserTrigger extends RepositoryBase {

    Use TQuery;

    protected $table = 'USER_TRIGGER';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    /**
     * @param $nrorg
     * @return array
     */
    public function findAllUserTrigger(): array
    {
        $query = "SELECT
                    'N'          IDMARCADO,
                    TABLE_NAME    NMTABELA,
                    TRIGGER_NAME  NMGATILHO,
                  STATUS        DSSITUACAO
                  FROM USER_TRIGGERS
                  WHERE TRIGGER_NAME LIKE 'LOG_%'
                  ORDER BY TABLE_NAME, TRIGGER_NAME";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}
