/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3913_CDPSTP0.SQL

Descrio:
Rotina para gerao de Ordem de Produo (OP) a partir de pedidos

@C:\Web_649\Sql\End_Conv\Oracle\xxx_CDPSTPO_GERA_OP_PEDIDO.SQL

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');
-- raise_application_error(-20501, '**'||V_NRORDPROD||'**', True);

*/
create or replace PROCEDURE GERA_OP_PEDIDO
   (P_CDFILIAL          IN FILIAL.CDFILIAL%TYPE,
    P_NRSEQTRABPEDIDOOP IN TRABPEDIDOOP.NRSEQTRABPEDIDOOP%TYPE
   ) AS
   V_DSNUMELOTEPR   PARAMAN.DSNUMELOTEPR%TYPE;
   V_DSSEQULOTEPR   PARAMAN.DSSEQULOTEPR%TYPE;
   V_SEQNRORDPROD   VARCHAR2(20);
   V_NRORDPROD      ORDPRODUCAO.NRORDPROD%TYPE;
   V_NRSUBORDPROD   ORDPRODUCAO.NRSUBORDPROD%TYPE;
   V_NRORDPRODPA    ORDPRODUCAO.NRORDPROD%TYPE;
   V_NRORDENASUBOPPA ORDPRODUCAO.NRSUBORDPROD%TYPE;
   V_NRLOTEESTQ     LOTE.NRLOTEESTQ%TYPE;
   V_NRLOTEEXIST    LOTE.NRLOTEESTQ%TYPE;
   V_NRSUBLOTE      LOTE.NRSUBLOTE%TYPE;
   V_PRODPREVI      PRODUTO.CDPRODUTO%TYPE;
   V_CDSETORPROD    SETOR.CDSETOR%TYPE;
   V_NRSEQPREVI     ITPREVCOMP.NRITPREVCOMP%TYPE;
   V_EXISPREVI      PRODUTO.CDPRODUTO%TYPE;
   V_CDPRODFINAL    CALEPRODMRP.CDPRODFINAL%TYPE;
   V_NRORDENAOP     CALEPRODMRP.NRORDENAOP%TYPE;
   V_NRORDENASUBOP  CALEPRODMRP.NRORDENAOP%TYPE;
   V_DTVALILOTE     LOTE.DTVALILOTE%TYPE;
   V_IDSUBOPSEMIACA PARAMAN.IDSUBOPSEMIACA%TYPE;
   V_IDGERAOPCONF   PARAMPRODMRP.IDGERAOPCONF%TYPE;
   V_IDENTRSEQ      CHAR;
   V_IDUTEQUIPLAPROD PARAMAN.IDUTEQUIPLAPROD%TYPE;
   V_IDMRPPEDPREV   PROGPRODU.IDMRPPEDPREV%TYPE;
   V_DSORDPROD      ORDPRODUCAO.DSORDPROD%TYPE;
   V_IDUTRESELOTE   PARAMPEDIDO.IDUTRESELOTE%TYPE;
   V_NRLOTERESERVA  LOTE.NRLOTEESTQ%TYPE;
   V_NRRESPRODPED   RESERPRODPED.NRRESPRODPED%TYPE;
   V_IDCNTRESTOQ    PRODFILI.IDCNTRESTOQ%TYPE;
   V_IDUTCTRLLOTE   PRODFILI.IDUTCTRLLOTE%TYPE;
   V_VRFATOCONV     PRODUTO.VRFATOCONV%TYPE;
   V_IDPEDINDUSTRIA PEDIDO.IDPEDINDUSTRIA%TYPE;
   V_QTPADPROCFAB   FLOAT;
   V_CONTGEROP      FLOAT;
   V_QTDEOP         FLOAT;
   V_IDTPPROPOPF    VARCHAR2(1);
   V_IDTPARREDPF    VARCHAR2(1);
   V_CONTADOR       NUMBER;
   V_CONTADOR2      NUMBER;

   V_NRPEDIDO        ITEMPEDIDO.NRPEDIDO%TYPE;
   V_CDPRODUTO       ITEMPEDIDO.CDPRODUTO%TYPE;
   V_QTITEMPED       ITEMPEDIDO.QTITEMPED%TYPE;
   V_VRPREUNITPED    ITEMPEDIDO.VRPREUNITPED%TYPE;
   V_NRITEMPED       ITEMPEDIDO.NRITEMPED%TYPE;
   V_IDSITITEMPED    ITEMPEDIDO.IDSITITEMPED%TYPE;
   V_QTEXPITEMPED    ITEMPEDIDO.QTEXPITEMPED%TYPE;
   V_CDFILIAL        ITEMPEDIDO.CDFILIAL%TYPE;
   V_CDFATPRECO      ITEMPEDIDO.CDFATPRECO%TYPE;
   V_QTITEMPED2      ITEMPEDIDO.QTITEMPED2%TYPE;
   V_DTENTITPED      ITEMPEDIDO.DTENTITPED%TYPE;
   V_IDITPEDDIFER    ITEMPEDIDO.IDITPEDDIFER%TYPE;
   V_VRPESOITPED     ITEMPEDIDO.VRPESOITPED%TYPE;
   V_VRDESITPED      ITEMPEDIDO.VRDESITPED%TYPE;
   V_IDITPEDRESER    ITEMPEDIDO.IDITPEDRESER%TYPE;
   V_VRPRTABITPED    ITEMPEDIDO.VRPRTABITPED%TYPE;
   V_VRPEDEMAXIPE    ITEMPEDIDO.VRPEDEMAXIPE%TYPE;
   V_CDOPERADOR      ITEMPEDIDO.CDOPERADOR%TYPE;
   V_VRPERCMARKUPIT  ITEMPEDIDO.VRPERCMARKUPIT%TYPE;
   V_CDTIPODESC      ITEMPEDIDO.CDTIPODESC%TYPE;
   V_DSITEMPED       ITEMPEDIDO.DSITEMPED%TYPE;
   V_DSEMISSAOITPED  ITEMPEDIDO.DSEMISSAOITPED%TYPE;
   V_DSPRAZOENTITPED ITEMPEDIDO.DSPRAZOENTITPED%TYPE;
   V_CDEMISSAOITPED  ITEMPEDIDO.CDEMISSAOITPED%TYPE;
   V_NRITORDEMCMPPED ITEMPEDIDO.NRITORDEMCMPPED%TYPE;
   V_IDPRECOPROM     ITEMPEDIDO.IDPRECOPROM%TYPE;
   V_VRVARIAVEL      ITEMPEDIDO.VRVARIAVEL%TYPE;
   V_CDFATOR         ITEMPEDIDO.CDFATOR%TYPE;
   V_IDITEMPEDTERC   ITEMPEDIDO.IDITEMPEDTERC%TYPE;

   V_CDEMPRESA    FILIAL.CDEMPRESA%TYPE;
   V_CDINSCESTA   FILIAL.CDINSCESTA%TYPE;
   V_CDCLIENTE    PEDIDO.CDCLIENTE%TYPE;
   V_CDFILIALPED  PEDIDO.CDFILIALPED%TYPE;
   V_NRPEDID      PEDIDO.NRPEDIDO%TYPE;
   V_CDTIPOOPER   PEDIDO.CDTIPOOPER%TYPE;
   V_IDORIGDESTOP TIPOOPERAC.IDORIGDESTOP%TYPE;
   V_CDVENDEDOR   PEDIDO.CDVENDEDOR%TYPE;

   V_CDPRODESTO     PRODUTO.CDPRODUTO%TYPE;
   V_CDPRODEMANDA   PRODUTO.CDPRODUTO%TYPE;
   V_QTSEMIACAB     FLOAT;
   V_QTESTOQDIA     FLOAT;
   V_QTDEMANDA      FLOAT;
   V_QTESTOQUE      FLOAT;
   V_QTHRETFABRIC   FLOAT;
   V_DTHRFIMPREOP   DATE;
   V_CALCTIME       NUMBER;
   V_QTOP           FLOAT;
   V_IDCONSESTGEROP PARAMPEDIDO.IDCONSESTGEROP%TYPE;
BEGIN
   /* Verifica parmetros do manufatura */
   SELECT
      MAX(DSNUMELOTEPR),
      MAX(DSSEQULOTEPR),
      NVL(MAX(IDSUBOPSEMIACA),'N'),
      MAX(NVL(IDENTRSEQLOTE,'N')),
      MAX(NVL(IDUTEQUIPLAPROD, 'N'))
   INTO
      V_DSNUMELOTEPR,
      V_DSSEQULOTEPR,
      V_IDSUBOPSEMIACA,
      V_IDENTRSEQ,
      V_IDUTEQUIPLAPROD
   FROM
      PARAMAN M, PARAMFILIAL F
   WHERE
      M.CDFILIAL = P_CDFILIAL    AND
      M.CDFILIAL = F.CDFILIAL;

   SELECT MAX(IDUTRESELOTE), NVL(MAX(IDCONSESTGEROP), 'N')
   INTO V_IDUTRESELOTE, V_IDCONSESTGEROP
   FROM PARAMPEDIDO
   WHERE
       CDFILIAL = P_CDFILIAL;

   V_QTDEMANDA   := 0;
   V_QTESTOQDIA  := 0;
   V_QTDEOP      := 0;

   DELETE FROM ESTSEMIACAB;

   IF V_IDCONSESTGEROP = 'S' THEN
      FOR C_DEMANDA IN (SELECT T.CDFILIAL, P.CDPROCFABRIC, PR.CDPRODESTO AS CDPRODUTO,  SUM(I.QTITEMPED - NVL(I.QTEXPITEMPED,0)) AS QUANTIDADE
                          FROM TRABPEDIDOOP T JOIN ITEMPEDIDO I
                                               ON T.CDFILIAL = I.CDFILIAL
                                              AND T.NRPEDIDO = I.NRPEDIDO
                                              AND T.NRITEMPED = I.NRITEMPED
                                             JOIN PRODUTO PR
                                               ON I.CDPRODUTO = PR.CDPRODUTO
                                             JOIN PROCFABRICA P
                                               ON I.CDFILIAL = P.CDFILIAL
                                              AND PR.CDPRODESTO = P.CDPRODUTO
                         WHERE T.CDFILIAL = P_CDFILIAL
                           AND T.NRSEQTRABPEDIDOOP = P_NRSEQTRABPEDIDOOP
                           AND P.IDPROFABPADR = 'S'
                           AND ((I.QTITEMPED - NVL(I.QTEXPITEMPED,0)) > 0)
                        GROUP BY T.CDFILIAL, P.CDPROCFABRIC, PR.CDPRODESTO)
      LOOP
         -- Consulta o estoque do dia para os produtos.
         BEGIN
            SELECT SUM(QTESTDIACON)
              INTO V_QTESTOQDIA
              FROM POSESTCONS PE
             WHERE PE.CDFILIAL = C_DEMANDA.CDFILIAL
               AND PE.CDPRODUTO = C_DEMANDA.CDPRODUTO
               AND PE.QTESTDIACON <>  0
               AND (PE.DTPOSESTCON = (SELECT MAX(PO.DTPOSESTCON)
                                        FROM POSESTCONS PO
                                       WHERE PO.CDFILIAL     = PE.CDFILIAL
                                         AND PO.CDPRODUTO    = PE.CDPRODUTO
                                         AND PO.DTPOSESTCON <= SYSDATE+1
                                      ));
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_QTESTOQDIA := 0;
         END;

         IF V_QTESTOQDIA > 0 THEN

            -- Verifica se a quantidade em estoque j est salva na tabela temporria.
            BEGIN
               SELECT CDPRODUTO
                 INTO V_CDPRODEMANDA
                 FROM ESTSEMIACAB
                WHERE (CDFILIAL  = C_DEMANDA.CDFILIAL)
                  AND (CDPRODUTO = C_DEMANDA.CDPRODUTO);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CDPRODEMANDA := '';
             END;

            IF (NOT V_CDPRODEMANDA = '') THEN

               -- Altera a quantidade da demanda deste produto.
               UPDATE ESTSEMIACAB
                  SET QTDEMANDA = QTDEMANDA + C_DEMANDA.QUANTIDADE
                WHERE (CDFILIAL  = C_DEMANDA.CDFILIAL)
                  AND (CDPRODUTO = C_DEMANDA.CDPRODUTO);

            ELSE
               -- Insere a demanda e a quantidade disponvel do produto.
               INSERT INTO ESTSEMIACAB (CDFILIAL, CDPRODUTO, QTDEMANDA, QTESTOQUE, NRPEDIDO)
                                VALUES (C_DEMANDA.CDFILIAL, C_DEMANDA.CDPRODUTO, C_DEMANDA.QUANTIDADE, V_QTESTOQDIA, NULL);

            END IF;
         END IF;

         V_QTDEOP := C_DEMANDA.QUANTIDADE - V_QTESTOQDIA;

         IF V_QTDEOP > 0 THEN
            ESTOQUE_SEMIACABADO(C_DEMANDA.CDFILIAL, NULL, C_DEMANDA.CDPRODUTO, C_DEMANDA.CDPROCFABRIC, V_QTDEOP);
         END IF;
      END LOOP;
   END IF;

   V_QTDEOP      := 0;
   V_NRORDENAOP  := ' ';
   V_CDPRODFINAL := 'X';

   FOR C_OP IN (SELECT T.CDFILIAL,
                       PR.CDPRODESTO AS CDPRODUTO,
                       PF.CDPROCFABRIC,
                       SUM(I.QTITEMPED - NVL(I.QTEXPITEMPED,0)) AS QTAFABRICMRP
                  FROM TRABPEDIDOOP T JOIN ITEMPEDIDO I
                                        ON T.CDFILIAL = I.CDFILIAL
                                       AND T.NRPEDIDO = I.NRPEDIDO
                                       AND T.NRITEMPED = I.NRITEMPED
                                      JOIN PRODUTO PR
                                        ON I.CDPRODUTO = PR.CDPRODUTO
                                      JOIN PROCFABRICA PF
                                        ON PF.CDFILIAL = I.CDFILIAL
                                       AND PF.CDPRODUTO = PR.CDPRODESTO
                 WHERE (T.CDFILIAL = P_CDFILIAL)
                   AND (T.NRSEQTRABPEDIDOOP = P_NRSEQTRABPEDIDOOP)
                   AND ((I.QTITEMPED - NVL(I.QTEXPITEMPED,0))     > 0                ) 
                   AND (PF.IDPROFABPADR = 'S')
                GROUP BY T.CDFILIAL, PR.CDPRODESTO, PF.CDPROCFABRIC)
   LOOP
      V_QTDEMANDA := 0;

      -- Consulta tabela temporria de estoque.
      BEGIN
         SELECT QTESTOQUE
           INTO V_QTESTOQUE
           FROM ESTSEMIACAB
          WHERE (CDFILIAL  = C_OP.CDFILIAL)
            AND (CDPRODUTO = C_OP.CDPRODUTO);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_QTESTOQUE    := 0;
      END;

      IF V_QTESTOQUE > 0 THEN
         V_QTDEMANDA := C_OP.QTAFABRICMRP - V_QTESTOQUE;

         IF (V_QTESTOQUE - C_OP.QTAFABRICMRP) > 0 THEN
            -- Altera a quantidade de estoque deste produto.
            UPDATE ESTSEMIACAB
               SET QTESTOQUE = QTESTOQUE - C_OP.QTAFABRICMRP
             WHERE (CDFILIAL  = C_OP.CDFILIAL)
               AND (CDPRODUTO = C_OP.CDPRODUTO);
         ELSE
            -- Zera a quantidade de estoque deste produto.
            UPDATE ESTSEMIACAB
               SET QTESTOQUE = 0
             WHERE (CDFILIAL  = C_OP.CDFILIAL)
               AND (CDPRODUTO = C_OP.CDPRODUTO);
         END IF;

      ELSE
         V_QTDEMANDA := C_OP.QTAFABRICMRP;
      END IF;

      IF V_QTDEMANDA > 0 THEN

         /* Gera o nmero do Lote de Produo */
         PRXLOTEPROD(C_OP.CDFILIAL, SYSDATE, C_OP.CDPRODUTO, V_NRLOTEESTQ);
         V_NRSUBLOTE := ' ';

         V_DTVALILOTE := VALIDADE_PRODUTO(C_OP.CDPRODUTO, SYSDATE);

         SELECT MAX(NRLOTEESTQ)
           INTO V_NRLOTEEXIST
           FROM LOTE
          WHERE CDFILIAL     = C_OP.CDFILIAL
            AND CDPRODUTO    = C_OP.CDPRODUTO
            AND NRLOTEESTQ   = V_NRLOTEESTQ;

         IF V_NRLOTEEXIST IS NULL THEN
            INSERT INTO LOTE
               (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
               DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
            VALUES
               (C_OP.CDFILIAL, V_NRLOTEESTQ, V_NRSUBLOTE, C_OP.CDPRODUTO, 'I',
                SYSDATE, V_DTVALILOTE, '1', NULL);
         END IF;

         /* Gera o nmero da OP/SubOP */
         NOVO_CODIGO_SC('NRORDPROD'||C_OP.CDFILIAL, V_SEQNRORDPROD, 1);
         V_NRORDPROD     := SUBSTR(V_SEQNRORDPROD, 11, 10);
         V_NRORDENASUBOP := '0';

         BEGIN
            SELECT NVL(IDGERAOPCONF,'N')
              INTO V_IDGERAOPCONF
              FROM PARAMPRODMRP
             WHERE CDFILIAL = C_OP.CDFILIAL
               AND CDPRODUTO =  C_OP.CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDGERAOPCONF := 'N';
         END;

         SELECT MAX(NVL(T.QTHRETFABRPR, 0)) AS QTHRETFABRIC
           INTO V_QTHRETFABRIC
           FROM ETAFABRIC E LEFT JOIN TEMPOETAFABR T
                                   ON E.CDFILIAL     = T.CDFILIAL
                                  AND E.CDPRODUTO    = T.CDPRODUTO
                                  AND E.CDPROCFABRIC = T.CDPROCFABRIC
                                  AND E.CDETAPAPROD  = T.CDETAPAPROD
          WHERE (E.CDFILIAL     = C_OP.CDFILIAL)
            AND (E.CDPRODUTO    = C_OP.CDPRODUTO)
            AND (E.CDPROCFABRIC = C_OP.CDPROCFABRIC)
            AND (V_QTDEMANDA BETWEEN VRINIQTFABPR AND VRFINQTFABPR);

         V_CALCTIME     := ((V_QTDEMANDA * V_QTHRETFABRIC) / V_QTPADPROCFAB);
         V_DTHRFIMPREOP := SYSDATE + NUMTODSINTERVAL(V_CALCTIME, 'HOUR');

         INSERT INTO ORDPRODUCAO
            (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO,
             CDPROCFABRIC, IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
            DTHRINIPREOP,DTHRFIMPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP,
            NRPEDIDO, NRITEMPED)
         VALUES
            (C_OP.CDFILIAL, V_NRORDPROD, V_NRORDENASUBOP, C_OP.CDPRODUTO,
             C_OP.CDPROCFABRIC, '1', '3', SYSDATE, V_QTDEMANDA,
             SYSDATE, V_DTHRFIMPREOP,V_NRLOTEESTQ, V_NRSUBLOTE, NULL, NULL, V_IDGERAOPCONF,
             NULL, NULL);

         FOR C_UPDTRABPEDIDOOP IN (SELECT T.CDFILIAL, T.NRPEDIDO, T.NRITEMPED, PR.CDPRODUTO
                                     FROM TRABPEDIDOOP T JOIN ITEMPEDIDO I
                                                           ON T.CDFILIAL = I.CDFILIAL
                                                          AND T.NRPEDIDO = I.NRPEDIDO
                                                          AND T.NRITEMPED = I.NRITEMPED
                                                         JOIN PRODUTO P
                                                           ON I.CDPRODUTO = P.CDPRODESTO
                                                         JOIN PRODUTO PR
                                                           ON P.CDPRODUTO = PR.CDPRODUTO
                                    WHERE T.CDFILIAL = C_OP.CDFILIAL
                                      AND T.NRSEQTRABPEDIDOOP = P_NRSEQTRABPEDIDOOP
                                      AND PR.CDPRODUTO = C_OP.CDPRODUTO)
         LOOP
            UPDATE TRABPEDIDOOP
               SET NRORDPROD = V_NRORDPROD,
                   NRSUBORDPROD = V_NRORDENASUBOP
             WHERE CDFILIAL = C_UPDTRABPEDIDOOP.CDFILIAL
               AND NRPEDIDO = C_UPDTRABPEDIDOOP.NRPEDIDO
               AND NRITEMPED = C_UPDTRABPEDIDOOP.NRITEMPED
               AND NRSEQTRABPEDIDOOP = P_NRSEQTRABPEDIDOOP;

            UPDATE ITEMPEDIDO
               SET DSITEMPED = 'OP: '||V_NRORDPROD||'/'||V_NRORDENASUBOP
             WHERE CDFILIAL  = C_UPDTRABPEDIDOOP.CDFILIAL
               AND NRPEDIDO  = C_UPDTRABPEDIDOOP.NRPEDIDO
               AND NRITEMPED = C_UPDTRABPEDIDOOP.NRITEMPED;


            SELECT MAX(IDCNTRESTOQ), MAX(IDUTCTRLLOTE)
              INTO V_IDCNTRESTOQ, V_IDUTCTRLLOTE
              FROM PRODFILI
             WHERE CDPRODUTO = C_UPDTRABPEDIDOOP.CDPRODUTO
               AND CDFILIAL = C_UPDTRABPEDIDOOP.CDFILIAL;

            IF ((V_IDCNTRESTOQ = 'S') AND (V_IDUTCTRLLOTE = 'S')) THEN

               SELECT MAX(NRRESPRODPED), MAX(NRLOTEESTQ)
                 INTO V_NRRESPRODPED, V_NRLOTERESERVA
                 FROM RESERPRODPED
                WHERE CDFILIAL  = C_UPDTRABPEDIDOOP.CDFILIAL
                  AND NRPEDIDO  = C_UPDTRABPEDIDOOP.NRPEDIDO
                  AND NRITEMPED = C_UPDTRABPEDIDOOP.NRITEMPED;

               /* Verifica se existe uma reserva sem lote para este item */
               IF NOT (V_NRRESPRODPED IS NULL) THEN
                  IF (V_NRLOTERESERVA IS NULL) THEN

                     UPDATE RESERPRODPED
                        SET NRLOTEESTQ = V_NRLOTEESTQ,
                            NRSUBLOTE  = V_NRSUBLOTE
                      WHERE CDFILIAL  = C_UPDTRABPEDIDOOP.CDFILIAL
                        AND NRPEDIDO  = C_UPDTRABPEDIDOOP.NRPEDIDO
                        AND NRITEMPED = C_UPDTRABPEDIDOOP.NRITEMPED;
                  END IF;
               END IF;
            END IF;

            UPDATE ORDPRODUCAO
               SET DSORDPROD = DSORDPROD || ' Ordem de Produo gerada atravs da Aprovao do Pedido : '||C_UPDTRABPEDIDOOP.NRPEDIDO||' Item: '||C_UPDTRABPEDIDOOP.NRITEMPED
             WHERE CDFILIAL = C_UPDTRABPEDIDOOP.CDFILIAL
               AND NRORDPROD = V_NRORDPROD
               AND NRSUBORDPROD = V_NRORDENASUBOP;
         END LOOP;

         FOR C_SEMIACABADO IN (SELECT I.CDPRODUTO   ,
                                      I.CDETAPAPROD ,
                                      I.CDPRODINSUMO,
                                      F.CDPROCFABRIC,
                                      (SYSDATE) AS DTVALIDADE,
                                      I.IDUTAPRREQET,
                                      I.IDSEMIACETAP,
                                      I.QTINSUMETAPA,
                                      I.QTRENDINSU  ,
                                      O.QTAPRODPREOP,
                                      QTPREVI_MATPRIMA(I.CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, O.QTAPRODPREOP) AS QTAINSUMPREOP
                                 FROM ORDPRODUCAO O JOIN INSUMETAPA  I
                                                      ON O.CDFILIAL     = I.CDFILIAL
                                                     AND O.CDPRODUTO    = I.CDPRODUTO
                                                     AND O.CDPROCFABRIC = I.CDPROCFABRIC
                                                    JOIN PROCFABRICA F
                                                      ON O.CDFILIAL     = F.CDFILIAL
                                                     AND O.CDPROCFABRIC = F.CDPROCFABRIC
                                                     AND O.CDPRODUTO    = F.CDPRODUTO
                                 WHERE (I.IDSEMIACETAP = 'S'            )
                                   AND (O.CDFILIAL     = C_OP.CDFILIAL     )
                                   AND (O.NRORDPROD    = V_NRORDPROD    )
                                   AND (O.NRSUBORDPROD = V_NRORDENASUBOP)
                                   AND (O.CDPRODUTO    = C_OP.CDPRODUTO   )
                               ORDER BY I.CDETAPAPROD, I.CDPRODINSUMO)
         LOOP

            IF C_SEMIACABADO.QTAINSUMPREOP > 0 THEN

               V_QTSEMIACAB := 0;

               -- Consulta tabela temporria de estoque.

               BEGIN
                  SELECT QTESTOQUE
                    INTO V_QTESTOQUE
                    FROM ESTSEMIACAB
                   WHERE (CDFILIAL  = C_OP.CDFILIAL)
                     AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_QTESTOQUE    := 0;
               END;

               IF V_QTESTOQUE > 0 THEN
                  V_QTSEMIACAB := C_SEMIACABADO.QTAINSUMPREOP - V_QTESTOQUE;

                  IF (V_QTESTOQUE - C_SEMIACABADO.QTAINSUMPREOP) > 0 THEN
                     -- Altera a quantidade de estoque deste produto.
                     UPDATE ESTSEMIACAB
                        SET QTESTOQUE  = QTESTOQUE - C_SEMIACABADO.QTAINSUMPREOP
                       WHERE (CDFILIAL  = C_OP.CDFILIAL)
                         AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
                  ELSE
                     -- Zera a quantidade de estoque deste produto.
                     UPDATE ESTSEMIACAB
                        SET QTESTOQUE  = 0
                      WHERE (CDFILIAL  = C_OP.CDFILIAL)
                        AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
                  END IF;

               ELSE
                  V_QTSEMIACAB := C_SEMIACABADO.QTAINSUMPREOP;
               END IF;

               IF V_QTSEMIACAB > 0 THEN

                  GERA_OP_SEMIACABADO(C_OP.CDFILIAL, C_SEMIACABADO.CDPRODINSUMO, C_SEMIACABADO.CDPROCFABRIC, '1', '3', SYSDATE, C_SEMIACABADO.DTVALIDADE,
                                      V_QTSEMIACAB, NULL, NULL, V_IDGERAOPCONF, NULL, NULL, 'N', 'N', NULL, NULL, NULL,
                                      P_NRSEQTRABPEDIDOOP, C_OP.CDPRODUTO);
               END IF;
            END IF;
         END LOOP;
      END IF;
   END LOOP;

   -- Limpa a tabela de estoque temporria.
   DELETE FROM ESTSEMIACAB;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_OP_PEDIDO','6.49.068'); END;
/
